//Mugurel Ionut Andreica
#include <stdio.h>
#include <string.h>
#include <time.h>

#define KMAX 401
#define SIGMA 26
#define MOD 666013

int ns[SIGMA + 1][KMAX][SIGMA], total[SIGMA + 1][KMAX];
int ns_first[SIGMA + 1][KMAX][SIGMA][2], total_first[SIGMA + 1][KMAX][2];
int N, K;

void read_input() {
	freopen("frumos.in", "r", stdin);
	scanf("%d %d", &N, &K);
}

void compute() {
	int i, j, k, r, p, q, pnext, cnt, current_sum;
	int current_sum_first[2];

	for (i = 1; i <= N; i++) {
		memset(ns[i % (SIGMA + 1)], 0, sizeof(ns[i % (SIGMA + 1)]));
		memset(ns_first[i % (SIGMA + 1)], 0, sizeof(ns_first[i % (SIGMA + 1)]));
		memset(total[i % (SIGMA + 1)], 0, sizeof(total[i % (SIGMA + 1)]));
		memset(total_first[i % (SIGMA + 1)], 0, sizeof(total_first[i % (SIGMA + 1)]));

		if (i == 1)
			continue;

		for (k = 1; k <= K && k <= i; k++) {
			for (j = 0; j < SIGMA; j++) {
				// Variaza toate progresiile de lungime >= 2 care se termina cu caracterul j.
				for (r = -j; j + r < SIGMA; r++) {
					if (r == 0)
						continue;
					for (cnt = 2, p = j + r; p >= 0 && p < SIGMA && cnt <= i; p += r, cnt++) {
						if (i == cnt) {
							current_sum_first[0] = current_sum_first[1] = 0;
							if (k == 1) {
								current_sum = 1;
								if (cnt == 2)
									current_sum_first[0] = 1;
								else if (cnt == 3)
									current_sum_first[1] = 1;
							} else
								current_sum = 0;
						} else {
							pnext = p + r;
							if (pnext >= 0 && pnext < SIGMA) {
								current_sum = (total[(i - cnt) % (SIGMA + 1)][k - 1] - ns[(i - cnt) % (SIGMA + 1)][k - 1][pnext] - ns[(i - cnt) % (SIGMA + 1)][k - 1][p] + 2 * MOD) % MOD;
								for (q = 0; q < 2; q++)
									current_sum_first[q] = (total_first[(i - cnt) % (SIGMA + 1)][k - 1][q] - ns_first[(i - cnt) % (SIGMA + 1)][k - 1][pnext][q] - ns_first[(i - cnt) % (SIGMA + 1)][k - 1][p][q] + 2 * MOD) % MOD;
							} else {
								current_sum = (total[(i - cnt) % (SIGMA + 1)][k - 1] - ns[(i - cnt) % (SIGMA + 1)][k - 1][p] + MOD) % MOD;
								for (q = 0; q < 2; q++)
									current_sum_first[q] = (total_first[(i - cnt) % (SIGMA + 1)][k - 1][q] - ns_first[(i - cnt) % (SIGMA + 1)][k - 1][p][q] + MOD) % MOD;
							}
						}
						
						ns[i % (SIGMA + 1)][k][j] = (ns[i % (SIGMA + 1)][k][j] + current_sum) % MOD;
						for (q = 0; q < 2; q++)
							ns_first[i % (SIGMA + 1)][k][j][q] = (ns_first[i % (SIGMA + 1)][k][j][q] + current_sum_first[q]) % MOD;
					}
				}
				
				total[i % (SIGMA + 1)][k] = (total[i % (SIGMA + 1)][k] + ns[i % (SIGMA + 1)][k][j]) % MOD;
				for (q = 0; q < 2; q++)
					total_first[i % (SIGMA + 1)][k][q] = (total_first[i % (SIGMA + 1)][k][q] + ns_first[i % (SIGMA + 1)][k][j][q]) % MOD;
			}
			
			//fprintf(stderr, "(i=%d,k=%d) [>=2]=%d, total_first_2=%d, total_first_3=%d\n", i, k, total[i % (SIGMA + 1)][k], total_first[i % (SIGMA + 1)][k][0], total_first[i % (SIGMA + 1)][k][1]);
		}
	}

	if (N == 1)
		total[1][1] = SIGMA % MOD;
	else {
		int Nm1Km1_ge2 = total[(N - 1) % (SIGMA + 1)][K - 1];
		int NKm1_ge3 = (total[N % (SIGMA + 1)][K - 1] - total_first[N % (SIGMA + 1)][K - 1][0] + MOD) % MOD;
		
		//fprintf(stderr, "(N-1=%d,K-1=%d) [first>=2]=%d (x25 = %d)\n", N - 1, K - 1, Nm1Km1_ge2, (Nm1Km1_ge2 * (SIGMA - 1)) % MOD);
		//fprintf(stderr, "(N=%d,K-1=%d) [first>=3]=%d\n", N, K - 1, NKm1_ge3);
		int extra_num = (Nm1Km1_ge2 * (SIGMA - 1) - NKm1_ge3 + MOD) % MOD;
		//fprintf(stderr, "(N=%d,K=%d) [first>=2]=%d\n", N, K, total[N % (SIGMA + 1)][K]);
		//fprintf(stderr, "(N=%d,K=%d) [first=1]=%d\n", N, K, extra_num);

		total[N % (SIGMA + 1)][K] = (total[N % (SIGMA + 1)][K] + extra_num) % MOD;
	}
}

void write_output() {
	freopen("frumos.out", "w", stdout);
	printf("%d\n", total[N % (SIGMA + 1)][K]);
	fprintf(stderr, "N=%d, K=%d, result=%d\n", N, K, total[N % (SIGMA + 1)][K]);
}

int main() {
	int tstart= clock();
	read_input();
	compute();
	write_output();
	fprintf(stderr, "Durata=%.3lf sec\n", (double) (clock() - tstart) / CLOCKS_PER_SEC);
	return 0;
}
