//Dragos Oprica Frumos - dinamica 40
#include <algorithm>
#include <fstream>
using namespace std;

#define SUM 25
#define DIM 105
#define PRIM 55
#define MOD 666013

ifstream fin ("frumos.in");
ofstream fout ("frumos.out");

int dp[DIM][DIM>>1][PRIM>>1][PRIM+5];
int N,K,ret;

void read () {

  fin>>N>>K;
}

inline int get (int x) {

  return x+SUM;
}

void solve () {
  int i,j,k,l,m;

  if (K>(N>>1)+1) {

    fout<<0;
    return ;
  }

  for (i='a'; i<='z'; ++i)
    dp[1][1][i][PRIM]=1;

  for (i=1; i<=N; ++i)
    for (j=1; j<=K; ++j)
      for (k='a'; k<='z'; ++k) {

        for (l='a'; l<='z'; ++l)
          if (k!=l) {

            dp[i+1][j][l][get (l-k)]+=dp[i][j][k][PRIM];
            if (dp[i+1][j][l][get (l-k)]>=MOD)
              dp[i+1][j][l][get (l-k)]-=MOD;
        }

        for (m=-SUM; m<=SUM; ++m)
          for (l='a'; l<='z'; ++l)
            if (k!=l) {

              if (l-k==m) {

                dp[i+1][j][l][get (m)]+=dp[i][j][k][get (m)];
                if (dp[i+1][j][l][get (m)]>=MOD)
                  dp[i+1][j][l][get (m)]-=MOD;
              }
              else {

                dp[i+1][j+1][l][PRIM]+=dp[i][j][k][get (m)];
                if (dp[i+1][j+1][l][PRIM]>=MOD)
                  dp[i+1][j+1][l][PRIM]-=MOD;
              }
            }
      }

  for (i='a'; i<='z'; ++i) {

    ret+=dp[N][K][i][PRIM];
    if (ret>=MOD)
      ret-=MOD;

    for (j=-SUM; j<=SUM; ++j) {

      ret+=dp[N][K][i][get (j)];
      if (ret>=MOD)
        ret-=MOD;
     }
  }

  fout<<ret;
}

int main () {

  read ();
  solve ();

  return 0;
}
